from django.shortcuts import render
from clfinanceApp.models import *
from clfinanceApp.serializers import *
from django.contrib.auth.decorators import login_required,user_passes_test
from django.utils.decorators import method_decorator
from django.shortcuts import render,redirect
from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework import status
from .serializers import *
import json

class ExpenseCategoriesApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_expenseCategories'), login_url='/auth/login/'))
    def get(self,request):
        #         branchId = getBranchId(request)
        #if not branchId : return redirect('clauthApp:home')
        all_expense_cats =ExpenseCategory.objects.all()
        all_expense_cats_serialized=ExpenseCategorySerializer(all_expense_cats,many=True)
        return render(request,"Clinic/clfinanceApp/expense_categories.html",{"all_expense_cats":all_expense_cats_serialized.data,'activePage':'ExpenseCategories'})
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.add_expenseCategories'), login_url='/auth/login/'))    
    def post(self,request):
        #         branchId = getBranchId(request)
        #if not branchId : return redirect('clauthApp:home')
        serializedObj= ExpenseCategorySerializer(data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

class ExpenseCategoryApi(APIView):
    def get_object(self,pk):
        try:
            return ExpenseCategory.objects.get(pk=pk)
        except ExpenseCategory.DoesNotExist:
            return None    
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_expenseCategories'), login_url='/auth/login/'))        
    def get(self,request,pk): 
        expense_catObj=self.get_object(pk)
        if expense_catObj :
            serializeobj= ExpenseCategorySerializer(expense_catObj)
            return Response(serializeobj.data,status=status.HTTP_200_OK)
        else : return Response(status=status.HTTP_404_NOT_FOUND)
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.change_expenseCategories'), login_url='/auth/login/'))
    def put(self,request,pk):
        obj=self.get_object(pk)
        serializedObj= ExpenseCategorySerializer(obj,data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.delete_expenseCategories'), login_url='/auth/login/'))
    def delete(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            try:
                obj.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)
